import sys, os, cv2
import numpy as np
import torch

if __name__ == "__main__":
    net = torch.load("lapsrn_model_epoch_4000.pth",
                     map_location="cpu")["model"]
    im = cv2.imread(sys.argv[1])[:, :, ::-1]
    im_ycrcb = cv2.cvtColor(im, cv2.COLOR_RGB2YCrCb)

    im_ycrcb_x2 = cv2.resize(im_ycrcb, dsize=(0, 0), fx=2, fy=2,
                             interpolation=cv2.INTER_CUBIC)
    im_ycrcb_x4 = cv2.resize(im_ycrcb, dsize=(0, 0), fx=4, fy=4,
                             interpolation=cv2.INTER_CUBIC)
    im_ycrcb_x8 = cv2.resize(im_ycrcb, dsize=(0, 0), fx=8, fy=8,
                             interpolation=cv2.INTER_CUBIC)

    im_y = im_ycrcb[:, :, 0][None, None, :, :].astype("float32") / 255

    y_x2, y_x4, y_x8 = net(torch.Tensor(im_y))
    y_x2 = y_x2.detach().numpy()
    y_x4 = y_x4.detach().numpy()
    y_x8 = y_x8.detach().numpy()

    y_x2 = np.clip(255 * y_x2, 0, 255).round().astype("uint8")
    im_ycrcb_x2[:, :, 0] = y_x2[0, 0, :, :]
    im_rgb_x2 = cv2.cvtColor(im_ycrcb_x2, cv2.COLOR_YCrCb2RGB)
    cv2.imwrite("x2.png", im_rgb_x2[:, :, ::-1])

    y_x4 = np.clip(255 * y_x4, 0, 255).round().astype("uint8")
    im_ycrcb_x4[:, :, 0] = y_x4[0, 0, :, :]
    im_rgb_x4 = cv2.cvtColor(im_ycrcb_x4, cv2.COLOR_YCrCb2RGB)
    cv2.imwrite("x4.png", im_rgb_x4[:, :, ::-1])

    y_x8 = np.clip(255 * y_x8, 0, 255).round().astype("uint8")
    im_ycrcb_x8[:, :, 0] = y_x8[0, 0, :, :]
    im_rgb_x8 = cv2.cvtColor(im_ycrcb_x8, cv2.COLOR_YCrCb2RGB)
    cv2.imwrite("x8.png", im_rgb_x8[:, :, ::-1])
